Index: issm/trunk/src/c/classes/Inputs/Inputs.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/Inputs.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/Inputs.cpp	(revision 26744)
@@ -76,4 +76,17 @@
 		if(this->inputs[i]) _printf_(setw(25)<<EnumToStringx(i+InputsSTARTEnum+1)<<": set as "<<EnumToStringx(this->inputs[i]->ObjectEnum())<<"\n");
 	}
+	return;
+}
+/*}}}*/
+void Inputs::DeepEcho(int enum_in){/*{{{*/
+	int index= EnumToIndex(enum_in);
+	if(this->inputs[index])this->inputs[index]->DeepEcho();
+	return;
+}
+/*}}}*/
+void Inputs::Echo(int enum_in){/*{{{*/
+	_printf_("Inputs Echo:\n");
+	int index= EnumToIndex(enum_in);
+	if(this->inputs[index])this->inputs[index]->Echo();
 	return;
 }
@@ -144,4 +157,14 @@
 				this->inputs[index]=input;
 			}
+			else if(object_enum==TransientInputEnum){
+				TransientInput* input=new TransientInput();
+				input->Marshall(marshallhandle);
+				this->inputs[index]=input;
+			}
+			else if(object_enum==DatasetInputEnum){
+				DatasetInput* input=new DatasetInput();
+				input->Marshall(marshallhandle);
+				this->inputs[index]=input;
+			}
 			else{
 				_error_("input "<<EnumToStringx(object_enum)<<" not supported");
@@ -232,4 +255,57 @@
 	/*Add copy*/
 	this->inputs[index_new] = copy;
+}
+/*}}}*/
+void Inputs::ZAXPY(IssmDouble alpha, int xenum, int yenum, int zenum){/*{{{*/
+
+	_assert_(this);
+
+	/*Get indices from enums*/
+	int index_x = EnumToIndex(xenum);
+	int index_y = EnumToIndex(yenum);
+	int index_z = EnumToIndex(zenum);
+
+	/*Delete output if it already exists*/
+	if(this->inputs[index_z]) delete this->inputs[index_z];
+
+	/*Make sure that old one exists*/
+	if(!this->inputs[index_x]) _error_("Input "<<EnumToStringx(xenum)<<" not found");
+	if(!this->inputs[index_y]) _error_("Input "<<EnumToStringx(yenum)<<" not found");
+
+	/*Make a copy*/
+	this->inputs[index_z]=this->inputs[index_y]->copy();
+
+	/*AXPY: */
+	this->inputs[index_z]->AXPY(this->inputs[index_x],alpha);
+}
+/*}}}*/
+void Inputs::AXPY(IssmDouble alpha, int xenum, int yenum ){/*{{{*/
+
+	_assert_(this);
+
+	/*Get indices from enums*/
+	int index_x = EnumToIndex(xenum);
+	int index_y = EnumToIndex(yenum);
+
+	/*Make sure that old one exists*/
+	if(!this->inputs[index_x]) _error_("Input "<<EnumToStringx(xenum)<<" not found");
+	if(!this->inputs[index_y]) _error_("Input "<<EnumToStringx(yenum)<<" not found");
+
+	/*AXPY: */
+	this->inputs[index_y]->AXPY(this->inputs[index_x],alpha);
+}
+/*}}}*/
+void     Inputs::Shift(int xenum, IssmDouble alpha){/*{{{*/
+
+	_assert_(this);
+
+	/*Get indices from enums*/
+	int index_x = EnumToIndex(xenum);
+
+	/*Make sure that x exists*/
+	if(!this->inputs[index_x]) _error_("Input "<<EnumToStringx(xenum)<<" not found");
+
+	/*Shift: */
+	this->inputs[index_x]->Shift(alpha);
 }
 /*}}}*/
Index: issm/trunk/src/c/classes/Inputs/Inputs.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/Inputs.h	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/Inputs.h	(revision 26744)
@@ -46,6 +46,11 @@
 		int      DeleteInput(int enum_type);
 		void     DuplicateInput(int original_enum,int new_enum);
+		void     ZAXPY(IssmDouble alpha, int xenum, int yenum, int zenum);
+		void     AXPY(IssmDouble alpha, int xenum, int yenum);
+		void     Shift(int inputenum, IssmDouble alpha);
 		void     DeepEcho(void);
+		void     DeepEcho(int enum_in);
 		void     Echo(void);
+		void     Echo(int enum_in);
 		bool     Exist(int enum_type);
 		void     GetInputsInterpolations(int* pnuminputs,int** pinterpolations,int** penum);
Index: issm/trunk/src/c/classes/Inputs/PentaInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/PentaInput.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/PentaInput.cpp	(revision 26744)
@@ -177,4 +177,13 @@
 		}
 	}
+	else if(interp_in==P0Enum && this->interpolation==P0Enum){
+		_assert_(this->N==1);
+		for(int i=0;i<numindices;i++){
+			int row = indices[i];
+			_assert_(row>=0);
+			_assert_(row<this->M);
+			this->values[row] = values_in[i];
+		}
+	}
 	else if(this->interpolation!=P1Enum && interp_in==P1Enum){
 		this->Reset(interp_in);
Index: issm/trunk/src/c/classes/Inputs/TransientInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 26744)
@@ -94,11 +94,25 @@
 void TransientInput::DeepEcho(void){/*{{{*/
 
-	int i;
-
 	_printf_("TransientInput:\n");
 	_printf_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")\n");
 	_printf_("   numtimesteps: " << this->numtimesteps << "\n");
 	_printf_("---inputs: \n");
-	for(i=0;i<this->numtimesteps;i++){
+	for(int i=0;i<this->numtimesteps;i++){
+		_printf_("   time: " << this->timesteps[i]<<"  ");
+		if(this->inputs[i]) this->inputs[i]->DeepEcho();
+		else                _printf_(" NOT SET! \n");
+	}
+}
+/*}}}*/
+void TransientInput::Configure(Parameters* params){/*{{{*/
+	this->parameters=params;
+}
+/*}}}*/
+void TransientInput::Echo(void){/*{{{*/
+	_printf_("TransientInput:\n");
+	_printf_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")\n");
+	_printf_("   numtimesteps: " << this->numtimesteps << "\n");
+	_printf_("---inputs: \n");
+	for(int i=0;i<this->numtimesteps;i++){
 		_printf_("   time: " << this->timesteps[i]<<"  ");
 		if(this->inputs[i]) this->inputs[i]->Echo();
@@ -107,29 +121,58 @@
 }
 /*}}}*/
-void TransientInput::Configure(Parameters* params){/*{{{*/
-	this->parameters=params;
-}
-/*}}}*/
-void TransientInput::Echo(void){/*{{{*/
-	this->DeepEcho();
-}
-/*}}}*/
 int  TransientInput::Id(void){ return -1; }/*{{{*/
 /*}}}*/
 void TransientInput::Marshall(MarshallHandle* marshallhandle){ /*{{{*/
-
-	if (marshallhandle->OperationNumber() == MARSHALLING_LOAD){
-		_error_("not implmented");
-		//inputs = new Inputs();
-	}
 
 	int object_enum = TransientInputEnum;
    marshallhandle->call(object_enum);
 
+	marshallhandle->call(this->numberofelements_local);
+	marshallhandle->call(this->numberofvertices_local);
 	marshallhandle->call(this->enum_type);
 	marshallhandle->call(this->numtimesteps);
 	marshallhandle->call(this->timesteps,numtimesteps);
-	//inputs->Marshall(marshallhandle);
-	_error_("not implemented");
+
+	/*Allocate memory if need be*/
+	if(marshallhandle->OperationNumber() == MARSHALLING_LOAD){
+		int N = this->numtimesteps; _assert_(N>=0 && N<1e6);
+		if(N){
+			this->inputs = xNew<Input*>(N);
+			for(int i=0;i<N;i++) this->inputs[i] = NULL;
+		}
+		else{
+			this->inputs = NULL;
+		}
+	}
+
+	/*Marshall!*/
+	if(marshallhandle->OperationNumber()!=MARSHALLING_LOAD){
+		for(int i=0;i<this->numtimesteps;i++){
+			_assert_(this->inputs[i]);
+			object_enum = this->inputs[i]->ObjectEnum();
+			marshallhandle->call(object_enum);
+			this->inputs[i]->Marshall(marshallhandle);
+		}
+	}
+	else{
+		for(int i=0;i<this->numtimesteps;i++){
+			marshallhandle->call(object_enum);
+
+			if(object_enum==TriaInputEnum){
+				TriaInput* triainput2=new TriaInput();
+				triainput2->Marshall(marshallhandle);
+				this->inputs[i]=triainput2;
+			}
+			else if(object_enum==PentaInputEnum){
+				PentaInput* pentainput2=new PentaInput();
+				pentainput2->Marshall(marshallhandle);
+				this->inputs[i]=pentainput2;
+			}
+			else{
+				_error_("input "<<EnumToStringx(object_enum)<<" not supported");
+			}
+		}
+	}
+
 }
 /*}}}*/
@@ -348,5 +391,4 @@
 PentaInput* TransientInput::GetPentaInput(int offset){/*{{{*/
 
-
 	/*Check offset*/
 	if(offset<0 || offset>this->numtimesteps-1){
@@ -379,6 +421,40 @@
 
 	/*First, recover current time from parameters: */
-	bool linear_interp;
-	this->parameters->FindParam(&linear_interp,TimesteppingInterpForcingsEnum);
+	bool linear_interp,cycle;
+	IssmDouble dt;
+	this->parameters->FindParam(&linear_interp,TimesteppingInterpForcingEnum);
+	this->parameters->FindParam(&cycle,TimesteppingCycleForcingEnum);
+	this->parameters->FindParam(&dt,TimesteppingTimeStepEnum);          /*transient core time step*/
+
+	/*Change input time if we cycle through the forcing*/
+	IssmDouble time0 = this->timesteps[0];
+	IssmDouble time1 = this->timesteps[this->numtimesteps - 1];
+
+	/*We need the end time to be the last timestep that would be taken*/
+	/* i.e., the case where GEMB has time stamps (finer timestep) after the last timestep */
+	IssmDouble nsteps = reCast<int,IssmDouble>(time1/dt);
+	if (reCast<IssmDouble>(nsteps)<time1/dt) nsteps=nsteps+1;
+	time1 = nsteps*dt;
+
+	if(cycle){
+
+		/*See by how many intervals we have to offset time*/
+		IssmDouble deltat = time1-time0;
+
+		//int num_intervals = floor((time-time0)/deltat); //Cannot do that because of AD!
+		int num_intervals = reCast<int,IssmDouble>(fabs(time-time0)/deltat);
+
+		/*Uncomment following line if you would like to apply a cycle BEFORE the time series starts*/
+		if(time<time0) num_intervals = -num_intervals-1;
+
+		if(fabs(time-time0)/deltat == reCast<IssmDouble>(num_intervals)){
+			/*Hack to make sure we always cover the last value of the series (discussion with Nicole)*/
+			time = time1;
+		}
+		else{
+			/*Now offset time so that we do the right interpolation below*/
+			time = time - num_intervals*deltat;
+		}
+	}
 
 	/*Figure step out*/
@@ -440,5 +516,4 @@
 		this->current_input->AXPY(input2,alpha2);
 	}
-
 }/*}}}*/
 void TransientInput::SetAverageAsCurrentTimeInput(IssmDouble start_time,IssmDouble end_time, int averaging_method){/*{{{*/
Index: issm/trunk/src/c/classes/Inputs/TriaInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TriaInput.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/TriaInput.cpp	(revision 26744)
@@ -384,4 +384,11 @@
 }
 /*}}}*/
+void TriaInput::Shift(IssmDouble alpha){/*{{{*/
+
+	/*Carry out the shift operation:*/
+	for(int i=0;i<this->M*this->N;i++) this->values[i] +=alpha;
+	for(int i=0;i<TriaRef::NumberofNodes(this->interpolation);i++) this->element_values[i] += alpha;
+}
+/*}}}*/
 void TriaInput::PointWiseMult(Input* xinput){/*{{{*/
 
Index: issm/trunk/src/c/classes/Inputs/TriaInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/TriaInput.h	(revision 25994)
+++ issm/trunk/src/c/classes/Inputs/TriaInput.h	(revision 26744)
@@ -40,4 +40,5 @@
 		void Pow(IssmDouble scalar);
 		void AXPY(Input* xinput,IssmDouble scalar);
+		void Shift(IssmDouble scalar);
 		void PointWiseMult(Input* xinput);
 		void Serve(int numindices,int* indices);
Index: issm/trunk/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk/src/c/classes/IoModel.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/IoModel.cpp	(revision 26744)
@@ -449,4 +449,16 @@
 }
 /*}}}*/
+void  IoModel::ConstantToInput(Inputs* inputs,Elements* elements,IssmDouble value, int vector_enum,int type){/*{{{*/
+
+	if (type==P1Enum){
+		for(Object* & object : elements->objects){
+			Element* element=xDynamicCast<Element*>(object);
+			element->InputCreateP1FromConstant(inputs,this,value,vector_enum);
+		}
+	}
+	else _error_("not supported yet!");
+	return;
+}
+/*}}}*/
 void  IoModel::DeclareIndependents(bool trace,IssmPDouble* X){/*{{{*/
 
@@ -600,9 +612,9 @@
 				record_name=xNew<char>(record_name_size+1);
 				record_name[record_name_size]='\0';
-				
+
 				/*Read record_name: */
 				if(fread(record_name,record_name_size*sizeof(char),1,fid)!=0){};
-				
-				_error_("error while looking in binary file. String " << record_name << " a string of size "<<record_name_size);
+
+				_error_("error while looking in binary file. String \"" << record_name << "\" is a string of size "<<record_name_size);
 			}
 
@@ -656,4 +668,5 @@
 					if(strcmp(record_name,"md.timestepping.type")==0) integer = IoCodeToEnumTimestepping(integer);
 					if(strcmp(record_name,"md.amr.type")==0) integer = IoCodeToEnumAmr(integer);
+					if(strcmp(record_name,"md.solidearth.settings.grdmodel")==0) integer = IoCodeToEnumGrd(integer);
 
 					/*Broadcast to other cpus*/
@@ -683,4 +696,7 @@
 							/*create DoubleParam: */
 							this->AddConstant(new IoConstant(scalar,record_name));
+						}
+						else{
+							if(fread(&pscalar,sizeof(IssmPDouble),1,this->fid)!=1) _error_("could not read scalar ");
 						}
 					  }
@@ -1822,8 +1838,4 @@
 				matrix=array[i];
 
-				//recover time vector: 
-				times=xNew<IssmDouble>(N);
-				for(int t=0;t<N;t++) times[t] = matrix[(M-1)*N+t];
-
 				//initialize transient input dataset:
 				TransientInput* transientinput=inputs->SetDatasetTransientInput(input_enum,i, times,N);
@@ -1837,5 +1849,4 @@
 					int        *vertexlids = xNew<int>(numvertices);
 					int        *vertexsids = xNew<int>(numvertices);
-
 
 					/*Recover vertices ids needed to initialize inputs*/
@@ -1847,4 +1858,9 @@
 
 					if(M==this->numberofvertices || M==(this->numberofvertices+1)){
+
+						//recover time vector: 
+						times=xNew<IssmDouble>(N);
+						if(M==this->numberofvertices) times[0] = matrix[M-1];
+						if(M==this->numberofvertices+1) for(int t=0;t<N;t++) times[t] = matrix[(M-1)*N+t];
 
 						IssmDouble* values=xNew<IssmDouble>(numvertices);
@@ -1865,8 +1881,12 @@
 						IssmDouble value;
 
+						//recover time vector: 
+						times=xNew<IssmDouble>(N);
+						if(M==this->numberofelements) times[0] = matrix[M-1];
+						if(M==this->numberofelements+1) for(int t=0;t<N;t++) times[t] = matrix[(M-1)*N+t];
+
 						for(int t=0;t<N;t++){ 
 
 							value=matrix[N*element->Sid()+t];
-							//if(element->Sid()==188 && t==0)_printf_("value: " << value << "\n");
 							switch(element->ObjectEnum()){
 								case TriaEnum:  transientinput->AddTriaTimeInput( t,1,&element->lid,&value,P0Enum); break;
@@ -1876,6 +1896,25 @@
 						}
 					}
+					else if(M==2 || M==1){
+						IssmDouble value;
+
+						//recover time vector: 
+						times=xNew<IssmDouble>(N);
+						if(M==1) times[0] = 0;
+						if(M==2) for(int t=0;t<N;t++) times[t] = matrix[(M-1)*N+t];
+
+						for(int t=0;t<N;t++){ 
+
+							value=matrix[t];
+							switch(element->ObjectEnum()){
+								case TriaEnum:  transientinput->AddTriaTimeInput( t,1,&element->lid,&value,P0Enum); break;
+								case PentaEnum:  transientinput->AddPentaTimeInput( t,1,&element->lid,&value,P0Enum); break;
+								default: _error_("Not implemented yet");
+							}
+						}
+
+					}
 					else _error_("FetchDataToInput error message: row size of MatArray elements should be either numberofelements (+1) or numberofvertices (+1)");
-					
+
 					xDelete<int>(vertexlids);
 					xDelete<int>(vertexsids);
@@ -2024,7 +2063,16 @@
 				scalar=pscalar;
 			}
+			#if _CODIPACK_MAJOR_==2
+			auto& tape_codi = IssmDouble::getTape();
+			tape_codi.registerInput(scalar);
+			codi_global.input_indices.push_back(scalar.getIdentifier());
+			#elif _CODIPACK_MAJOR_==1
 			auto& tape_codi = IssmDouble::getGlobalTape();
 			tape_codi.registerInput(scalar);
 			codi_global.input_indices.push_back(scalar.getGradientData());
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 		#else
 			if(X){
@@ -2097,10 +2145,24 @@
 			#if defined(_HAVE_CODIPACK_)
 				// FIXME codi here we just assign instead of using "operator <<="
+				#if _CODIPACK_MAJOR_==2
+				auto& tape_codi = IssmDouble::getTape();
+				#elif _CODIPACK_MAJOR_==1
 				auto& tape_codi = IssmDouble::getGlobalTape();
+				#else
+				#error "_CODIPACK_MAJOR_ not supported"
+				#endif
+
 				if(X){
 					for (int i=0;i<M*N;i++) {
 						matrix[i]=X[Xcount+i];
 						tape_codi.registerInput(matrix[i]);
+						#if _CODIPACK_MAJOR_==2
+						codi_global.input_indices.push_back(matrix[i].getIdentifier());
+						#elif _CODIPACK_MAJOR_==1
 						codi_global.input_indices.push_back(matrix[i].getGradientData());
+						#else
+						#error "_CODIPACK_MAJOR_ not supported"
+						#endif
+
 					}
 				}
@@ -2109,5 +2171,11 @@
 						matrix[i]=buffer[i];
 						tape_codi.registerInput(matrix[i]);
+						#if _CODIPACK_MAJOR_==2
+						codi_global.input_indices.push_back(matrix[i].getIdentifier());
+						#elif _CODIPACK_MAJOR_==1
 						codi_global.input_indices.push_back(matrix[i].getGradientData());
+						#else
+						#error "_CODIPACK_MAJOR_ not supported"
+						#endif
 					}
 				}
@@ -2922,5 +2990,12 @@
 		 * -> These parameters are not read for the CoDiPack ISSM version!
 		 */
+		#if _CODIPACK_MAJOR_==2
+		auto& tape_codi = IssmDouble::getTape();
+		#elif _CODIPACK_MAJOR_==1
 		auto& tape_codi = IssmDouble::getGlobalTape();
+		#else
+		#error "_CODIPACK_MAJOR_ not supported"
+		#endif
+
 		tape_codi.setActive();
 		#if _AD_TAPE_ALLOC_
@@ -2935,5 +3010,5 @@
 		/*
 		std::stringstream out_s;
-		IssmDouble::getGlobalTape().printStatistics(out_s);
+		IssmDouble::getTape().printStatistics(out_s);
 		_printf0_("StartTrace::Tape Statistics	   : TapeAlloc count=[" << codi_allocn << "]\n" << out_s.str());
 		*/
Index: issm/trunk/src/c/classes/IoModel.h
===================================================================
--- issm/trunk/src/c/classes/IoModel.h	(revision 25994)
+++ issm/trunk/src/c/classes/IoModel.h	(revision 26744)
@@ -123,4 +123,5 @@
 		void        CheckFile(void);
 		Param      *CopyConstantObject(const char* constant_name,int param_enum);
+		void        ConstantToInput(Inputs* inputs,Elements* elements,IssmDouble value, int vector_enum,int type);
 		IssmDouble *Data(const char* data_name);
 		void        DeclareIndependents(bool trace,IssmPDouble* X);
Index: issm/trunk/src/c/classes/Loads/Channel.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Channel.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Channel.cpp	(revision 26744)
@@ -320,5 +320,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -336,5 +336,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
Index: issm/trunk/src/c/classes/Loads/Friction.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 26744)
@@ -18,14 +18,51 @@
 Friction::Friction(){/*{{{*/
 	this->element=NULL;
-	this->dim=0;
 	this->law=0;
-
+	this->apply_dim = 1.;
+	this->domaintype=-1;
+	this->vx_input=NULL;
+	this->vy_input=NULL;
+	this->vz_input=NULL;
 }
 /*}}}*/
-Friction::Friction(Element* element_in,int dim_in){/*{{{*/
-
+Friction::Friction(Element* element_in){/*{{{*/
+	/* Determine the dimension according to the domain type automatically. 
+	 * There are exceptions, e.g. HO, which needs the user to specify the dimension used in Friciton.*/
 	this->element=element_in;
-	this->dim=dim_in;
+
+	/* Load necessary parameters */
 	element_in->FindParam(&this->law,FrictionLawEnum);
+	element_in->FindParam(&this->domaintype,DomainTypeEnum);
+
+	/* Load VxBase and VyBase for this special case */
+	switch(this->domaintype){
+		case Domain2DhorizontalEnum: 
+			this->apply_dim = 2.;
+			this->vx_input = element_in->GetInput(VxBaseEnum);			_assert_(this->vx_input); 
+			this->vy_input = element_in->GetInput(VyBaseEnum);			_assert_(this->vy_input);
+			this->vz_input = NULL;
+			break;
+      case Domain2DverticalEnum:
+			this->apply_dim = 2.;
+			this->vx_input = element_in->GetInput(VxEnum);				_assert_(this->vx_input);
+			this->vy_input = element_in->GetInput(VyEnum);				_assert_(this->vy_input);
+			this->vz_input = NULL;
+			break;
+      case Domain3DEnum:           
+			this->apply_dim = 3.;
+			this->vx_input = element_in->GetInput(VxEnum);				_assert_(this->vx_input);
+			this->vy_input = element_in->GetInput(VyEnum);				_assert_(this->vy_input);
+			this->vz_input = element_in->GetInput(VzEnum);				_assert_(this->vz_input);
+			break;
+      default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
+	}
+}
+/*}}}*/
+Friction::Friction(Element* element_in,int dim) : Friction(element_in) {/*{{{*/
+	this->apply_dim = reCast<IssmDouble>(dim);
+}
+/*}}}*/
+Friction::Friction(Element* element_in,IssmDouble dim) : Friction(element_in) {/*{{{*/
+	this->apply_dim = dim;
 }
 /*}}}*/
@@ -34,8 +71,9 @@
 /*}}}*/
 
+
 /*methods: */
 void Friction::Echo(void){/*{{{*/
 	_printf_("Friction:\n");
-	_printf_("   dim: " << this->dim<< "\n");
+	_printf_("   Domain type: " << this->domaintype<< "\n");
 }
 /*}}}*/
@@ -61,5 +99,4 @@
 			_error_("not supported");
 	}
-
 
 	/*Checks*/
@@ -160,7 +197,13 @@
 	IssmDouble vmag = VelMag(gauss);
 
-	/*Check to prevent dividing by zero if vmag==0*/
-	if(vmag==0. && (s-1.)<0.) alpha_complement=0.;
-	else alpha_complement=pow(Neff,r)*pow(vmag,(s-1));
+	if(s==1.){
+		/*This is to make AD happy and avoid 0^0*/
+		alpha_complement=pow(Neff,r);
+	}
+	else{
+		/*Check to prevent dividing by zero if vmag==0*/
+		if(vmag==0. && (s-1.)<0.) alpha_complement=0.;
+		else alpha_complement=pow(Neff,r)*pow(vmag,(s-1.));
+	}
 
 	/*Assign output pointers:*/
@@ -219,5 +262,5 @@
 	if(vmag==0. && (1./m-1.)<0.) alpha_complement=0.;
 	else alpha_complement= pow(vmag, 1.0/m-1.);
-	
+
 	/*Assign output pointers:*/
 	*palpha_complement=alpha_complement;
@@ -261,4 +304,7 @@
 		case 12:
 			GetAlpha2Tsai(palpha2,gauss);
+			break;
+		case 13:
+			GetAlpha2Coulomb2(palpha2,gauss);
 			break;
 	  default:
@@ -304,10 +350,12 @@
 	IssmDouble vmag = VelMag(gauss);
 
-	/*Check to prevent dividing by zero if vmag==0*/
-	if(vmag==0. && (s-1.)<0.){
-		alpha2=0.;
+	if(s==1.){
+		/*This is to make AD happy and avoid 0^0*/
+		alpha2=drag_coefficient*drag_coefficient*pow(Neff,r);
 	}
 	else{
-		alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
+		/*Check to prevent dividing by zero if vmag==0*/
+		if(vmag==0. && (s-1.)<0.) alpha2=0.;
+		else alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
 	}
 
@@ -461,5 +509,4 @@
 	deltaT = T-Tpmp;
 
-
 	/*Compute gamma*/
 	element->parameters->FindParam(&time,TimeEnum);
@@ -498,10 +545,31 @@
 
 	/*Get effective pressure and basal velocity*/
-	IssmDouble Neff = EffectivePressure(gauss);
 	IssmDouble vmag = VelMag(gauss);
 
+	bool ispwStochastic;
+	IssmDouble Neff;
+	element->parameters->FindParam(&ispwStochastic,StochasticForcingIsWaterPressureEnum);
+	if(ispwStochastic){
+		/*Retrieve stochastic water pressure and compute ice pressure*/
+		IssmDouble p_ice,p_water,Neff_limit;
+		element->GetInputValue(&p_water,gauss,FrictionWaterPressureEnum);
+		element->parameters->FindParam(&Neff_limit,FrictionEffectivePressureLimitEnum);
+		p_ice = IcePressure(gauss);
+		Neff  = max(Neff_limit*p_ice, p_ice - p_water);
+	}	
+	else{
+		/*Compute effective pressure directly*/
+		Neff = EffectivePressure(gauss);
+	}
+
 	/*Check to prevent dividing by zero if vmag==0*/
-	if(vmag==0. && (s-1.)<0.) alpha2=0.;
-	else alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
+	if(s==1.){
+		/*This is to make AD happy and avoid 0^0*/
+		alpha2=drag_coefficient*drag_coefficient*pow(Neff,r);
+	}
+	else{
+		if(vmag==0. && (s-1.)<0.) alpha2=0.;
+		else alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
+	}
 
 	/*Assign output pointers:*/
@@ -547,7 +615,13 @@
 	IssmDouble vmag = VelMag(gauss);
 
-	/*Check to prevent dividing by zero if vmag==0*/
-	if(vmag==0. && (s-1.)<0.) alpha2=0.;
-	else alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
+	if(s==1.){
+		/*This is to make AD happy and avoid 0^0*/
+		alpha2=drag_coefficient*drag_coefficient*pow(Neff,r);
+	}
+	else{
+		/*Check to prevent dividing by zero if vmag==0*/
+		if(vmag==0. && (s-1.)<0.) alpha2=0.;
+		else alpha2=drag_coefficient*drag_coefficient*pow(Neff,r)*pow(vmag,(s-1.));
+	}
 
 	/*Assign output pointers:*/
@@ -695,5 +769,5 @@
 
 	/*Compute alpha^2*/
-	if(ub<1e-10){
+	if((ub<1e-10) ||(N==0.0)){
 		alpha2 = 0.;
 	}
@@ -735,4 +809,36 @@
 
 		alpha2 = alpha2/ub;
+	}
+
+	/*Assign output pointers:*/
+	*palpha2=alpha2;
+}/*}}}*/
+void Friction::GetAlpha2Coulomb2(IssmDouble* palpha2, Gauss* gauss){/*{{{*/
+
+	/*This routine calculates the basal friction coefficient
+	 *
+	 *               C^2 |u_b|^(m-1) * (.5*N)
+	 * alpha2= ___________________________________
+	 *          (C^(2/m) |u_b| + (0.5*N)^(1/m) )^m
+	 *
+	 * */
+
+	/*diverse: */
+	IssmDouble  C,m,alpha2;
+
+	/*Recover parameters: */
+	element->GetInputValue(&C,gauss,FrictionCEnum);
+	element->GetInputValue(&m,gauss,FrictionMEnum);
+
+	/*Get effective pressure and velocity magnitude*/
+	IssmDouble N  = EffectivePressure(gauss);
+	IssmDouble ub = VelMag(gauss);
+
+	/*Compute alpha^2*/
+	if(ub<1e-10){
+		alpha2 = 0.;
+	}
+	else{
+		alpha2= (pow(C,2)*pow(ub,m-1.)*(0.5*N)) / pow(pow(C,2./m)*ub + pow(0.5*N,1./m),m);
 	}
 
@@ -754,14 +860,14 @@
 	element->parameters->FindParam(&Neff_limit,FrictionEffectivePressureLimitEnum);
 
+	/*Compute ice pressure*/
+	p_ice = IcePressure(gauss);
+
 	/*From base and thickness, compute effective pressure when drag is viscous, or get Neff from forcing:*/
 	switch(coupled_flag){
 		case 0:{
-			element->GetInputValue(&thickness, gauss,ThicknessEnum);
 			element->GetInputValue(&base, gauss,BaseEnum);
 			element->GetInputValue(&sealevel, gauss,SealevelEnum);
 			IssmDouble rho_water = element->FindParam(MaterialsRhoSeawaterEnum);
-			IssmDouble rho_ice   = element->FindParam(MaterialsRhoIceEnum);
 			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
-			p_ice   = gravity*rho_ice*thickness;
 			p_water = rho_water*gravity*(sealevel-base);
 			Neff = p_ice - p_water;
@@ -769,8 +875,4 @@
 			break;
 		case 1:{
-			element->GetInputValue(&thickness, gauss,ThicknessEnum);
-			IssmDouble rho_ice   = element->FindParam(MaterialsRhoIceEnum);
-			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
-			p_ice   = gravity*rho_ice*thickness;
 			p_water = 0.;
 			Neff = p_ice - p_water;
@@ -778,11 +880,8 @@
 			break;
 		case 2:{
-			element->GetInputValue(&thickness, gauss,ThicknessEnum);
 			element->GetInputValue(&base, gauss,BaseEnum);
 			element->GetInputValue(&sealevel, gauss,SealevelEnum);
 			IssmDouble rho_water = element->FindParam(MaterialsRhoSeawaterEnum);
-			IssmDouble rho_ice   = element->FindParam(MaterialsRhoIceEnum);
 			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
-			p_ice   = gravity*rho_ice*thickness;
 			p_water = max(0.,rho_water*gravity*(sealevel-base));
 			Neff = p_ice - p_water;
@@ -791,16 +890,8 @@
 		case 3:{
 			element->GetInputValue(&Neff,gauss,FrictionEffectivePressureEnum);
-			element->GetInputValue(&thickness, gauss,ThicknessEnum);
-			IssmDouble rho_ice   = element->FindParam(MaterialsRhoIceEnum);
-			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
-			p_ice   = gravity*rho_ice*thickness;
 		}
 			break;
 		case 4:{
 			element->GetInputValue(&Neff,gauss,EffectivePressureEnum);
-			element->GetInputValue(&thickness, gauss,ThicknessEnum);
-			IssmDouble rho_ice   = element->FindParam(MaterialsRhoIceEnum);
-			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
-			p_ice   = gravity*rho_ice*thickness;
 		}
 			break;
@@ -816,32 +907,111 @@
 
 }/*}}}*/
+IssmDouble Friction::IcePressure(Gauss* gauss){/*{{{*/
+	/*Get ice pressure*/
+
+	IssmDouble  thickness,p_ice;
+	/*Recover Inputs and Parameters*/
+	element->GetInputValue(&thickness, gauss,ThicknessEnum);
+	IssmDouble rho_ice = element->FindParam(MaterialsRhoIceEnum);
+	IssmDouble gravity = element->FindParam(ConstantsGEnum);
+
+	/*Compute*/
+	p_ice = gravity*rho_ice*thickness;
+
+	/*Return ice pressure*/
+	return p_ice;
+
+}/*}}}*/
+IssmDouble Friction::SubglacialWaterPressure(Gauss* gauss){/*{{{*/
+	/*Get water pressure as a function of  flag */
+
+	int         coupled_flag;
+	IssmDouble  base,sealevel,p_water;
+
+	/*Recover parameters: */
+	element->parameters->FindParam(&coupled_flag,FrictionCouplingEnum);
+
+	switch(coupled_flag){
+		case 0:{
+			element->GetInputValue(&base, gauss,BaseEnum);
+			element->GetInputValue(&sealevel, gauss,SealevelEnum);
+			IssmDouble rho_water = element->FindParam(MaterialsRhoSeawaterEnum);
+			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
+			p_water = rho_water*gravity*(sealevel-base);
+		}
+			break;
+		case 1:{
+			p_water = 0.;
+		}
+			break;
+		case 2:{
+			element->GetInputValue(&base, gauss,BaseEnum);
+			element->GetInputValue(&sealevel, gauss,SealevelEnum);
+			IssmDouble rho_water = element->FindParam(MaterialsRhoSeawaterEnum);
+			IssmDouble gravity   = element->FindParam(ConstantsGEnum);
+			p_water = max(0.,rho_water*gravity*(sealevel-base));
+		}
+			break;
+		case 3:{
+			_error_("water pressure not computed for coupling==3 in friction law");
+		}
+			break;
+		case 4:{
+			_error_("water pressure not computed for coupling==4 in friction law");
+		}
+			break;
+		default:
+			_error_("not supported");
+	}
+
+	/*Return water pressure*/
+	return p_water;
+
+}/*}}}*/
 IssmDouble Friction::VelMag(Gauss* gauss){/*{{{*/
-	/*Get effective pressure as a function of  flag */
-
+	/*Get the velocity magnitude as a function of flag */
 
 	/*diverse*/
 	IssmDouble vx,vy,vz,vmag;
 
-	switch(dim){
-		case 1:
-			element->GetInputValue(&vx,gauss,VxEnum);
-			vmag=sqrt(vx*vx);
-			break;
-		case 2:
-			element->GetInputValue(&vx,gauss,VxEnum);
-			element->GetInputValue(&vy,gauss,VyEnum);
-			vmag=sqrt(vx*vx+vy*vy);
-			break;
-		case 3:
-			element->GetInputValue(&vx,gauss,VxEnum);
-			element->GetInputValue(&vy,gauss,VyEnum);
-			element->GetInputValue(&vz,gauss,VzEnum);
-			vmag=sqrt(vx*vx+vy*vy+vz*vz);
-			break;
-		default:
-			_error_("not supported");
-	}
-
+	this->vx_input->GetInputValue(&vx, gauss);
+	this->vy_input->GetInputValue(&vy, gauss);
+
+	if ((this->vz_input == NULL) || (this->apply_dim<3.)) vz = 0.0;
+	else this->vz_input->GetInputValue(&vz, gauss);
+
+	if (this->apply_dim<2.) vy = 0.0;
+
+	vmag = sqrt(vx*vx+vy*vy+vz*vz);
 	return vmag;
-
-}/*}}}*/
+}/*}}}*/
+void Friction::GetBasalSlidingSpeeds(IssmDouble* pvx, Gauss* gauss){/*{{{*/
+
+	this->vx_input->GetInputValue(pvx, gauss);
+	/*Checks*/
+	_assert_(!xIsNan<IssmDouble>(*pvx));
+	_assert_(!xIsInf<IssmDouble>(*pvx));
+}/*}}}*/
+void Friction::GetBasalSlidingSpeeds(IssmDouble* pvx, IssmDouble* pvy, Gauss* gauss){/*{{{*/
+
+	this->vx_input->GetInputValue(pvx, gauss);
+	this->vy_input->GetInputValue(pvy, gauss);
+	/*Checks*/
+	_assert_(!xIsNan<IssmDouble>(*pvx));
+	_assert_(!xIsInf<IssmDouble>(*pvx));
+	_assert_(!xIsNan<IssmDouble>(*pvy));
+	_assert_(!xIsInf<IssmDouble>(*pvy));
+}/*}}}*/
+void Friction::GetBasalSlidingSpeeds(IssmDouble* pvx, IssmDouble* pvy, IssmDouble* pvz, Gauss* gauss){/*{{{*/
+
+	this->vx_input->GetInputValue(pvx, gauss);
+	this->vy_input->GetInputValue(pvy, gauss);
+	this->vz_input->GetInputValue(pvz, gauss);
+	/*Checks*/
+	_assert_(!xIsNan<IssmDouble>(*pvx));
+	_assert_(!xIsInf<IssmDouble>(*pvx));
+	_assert_(!xIsNan<IssmDouble>(*pvy));
+	_assert_(!xIsInf<IssmDouble>(*pvy));
+	_assert_(!xIsNan<IssmDouble>(*pvz));
+	_assert_(!xIsInf<IssmDouble>(*pvz));
+}/*}}}*/
